; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 800
WINDOWHEIGHT = 600
MAX_PARTICLES equ     1000
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
BMPFILE STRUCT
	header BITMAPFILEHEADER <>
	info BITMAPINFOHEADER <>
	data_ DWORD ?
BMPFILE ENDS
particles STRUCT
 active	db ?; (/)
 life	dd ?;
 fade	dd ?; 
 r	dd ?; 
 g	dd ?; 
 b	dd ?; 
 x	dd ?;X 
 y	dd ?;Y 
 z	dd ?;Z 
 xi	dd ?;X 
 yi	dd ?;Y 
 zi	dd ?;Z 
 xg	dd ?;X 
 yg	dd ?;Y 
 zg	dd ?;Z 
particles ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	FSize:dword
local	szReadWrite:dword	;number of bytes actually read or write
local	w:dword
local	h:dword
local	colormul:dword
local	x:dword
local	y:dword
local	z:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	mov	ecx,texture
	invoke	GlobalFree
	mov	ecx,particle
	invoke	GlobalFree
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
@@:	cmp	al,VK_ADD
	movd	xmm0,slowdown
	jne	@f
	comiss	xmm0,const1;if slowdown > 1.0 then slowdown -= 0.01
	jna	@1
	subss	xmm0,const0_01
	jmp	@1
@@:	cmp	al,VK_SUBTRACT
	jne	@f
	movd	xmm0,slowdown
	comiss	xmm0,const4;if slowdown < 4.0 then slowdown += 0.01
	jnb	@1
	addss	xmm0,const0_01
	movd	slowdown,xmm0
	jmp	@1
@@:	cmp	al,VK_RETURN
	jne	@f
	xor	rainbow,1
	jmp	@1
@@:	cmp	al,VK_NEXT                 
	jne	@f
	movd	xmm0,zoom
	subss	xmm0,const0_1;zoom-=0.1
	movd	zoom,xmm0
	jmp	@1
@@:	cmp	al,VK_PRIOR
	jne	@f
	movd	xmm0,zoom
	addss	xmm0,const0_1;zoom+=0.1
	movd	zoom,xmm0
	jmp	@1
@@:	cmp	al,VK_UP
	jne	@f
	movd	xmm0,yspeed
	comiss	xmm0,const200;if yspeed < 200 then yspeed += 1.0
	jnb	@1
	addss	xmm0,const1
	movd	yspeed,xmm0
	jmp	@1
@@:	cmp	al,VK_DOWN
	jne	@f
	movd	xmm0,yspeed
	comiss	xmm0,const_200;if yspeed > -200 then yspeed -= 1.0
	jna	@1
	subss	xmm0,const1
	movd	yspeed,xmm0
	jmp	@1
@@:	cmp	al,VK_RIGHT
	jne	@f
	movd	xmm0,xspeed
	comiss	xmm0,const200;if xspeed < 200 xspeed+=1.0
	jnb	@1
	addss	xmm0,const1
	movd	xspeed,xmm0
	jmp	@1
@@:	cmp	al,VK_LEFT
	jne	wmBYE
	movd	xmm0,xspeed
	comiss	xmm0,const_200;if xspeed > -200 xspeed-=1.0
	jna	@1
	subss	xmm0,const1
	movd	xspeed,xmm0
@1:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmTIMER:inc	col
        cmp	col,12
        jb	@f
	mov	col,0;1
@@:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,12,0
;-------------------------------------------------------
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,MAX_PARTICLES*sizeof particles
	mov	particle,eax
	mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	esi,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,eax
        mov	edi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,esi,eax,FSize,,rbx
        invoke	CloseHandle,esi
	mov	esi,edi
        add	esi,[rdi + BITMAPFILEHEADER.bfOffBits]
	lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	w,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	h,eax
;-------------------------------------------------------
 	mov	edx,offset Texture1_Id
	invoke	glGenTextures,1
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	mov	r9d,w
	mov	eax,h
        invoke  glTexImage2D,GL_TEXTURE_2D,0,3,,rax,rbx,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
;---------------------------------------------------------	
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;    
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
	invoke  glDisable,GL_DEPTH_TEST
  	invoke  glEnable,GL_BLEND
	invoke  glBlendFunc,GL_SRC_ALPHA,GL_ONE
	invoke  glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
	invoke  glHint,GL_POINT_SMOOTH_HINT,GL_NICEST
	invoke  glEnable,GL_TEXTURE_2D
	invoke  glBindTexture,GL_TEXTURE_2D,Texture1_Id
	movr	colormul,0.012;=12/MAX_PARTICLES=12/1000=0.012
	invoke  GetTickCount
	mov     nseed,eax
	mov     esi,particle
	xor     edi,edi
@@:	mov     [rsi+rdi].particles.active,1
        movr	[rsi+rdi].particles.life,1.0

        invoke	nrandom,100
        cvtsi2ss xmm0,edx
        divss	xmm0,const1000
        addss	xmm0,const0_003
        movd    [rsi+rdi].particles.fade,xmm0;(rand()%100)/1000.0+0.003
	mov	eax,edi
	xor	edx,edx
	mov	ecx,sizeof particles
	div	ecx
        cvtsi2ss xmm0,eax
        mulss	xmm0,colormul; compute the color index = loopcount * 12 / MAX_PARTICLES
        cvtss2si eax,xmm0; multiply the color index by 12 to point to the
        imul	eax,12                       ; right color, because each color is made of 3
        mov     ecx,colors[rax]       ; floats (r,g,b), and floats are 4 bytes so 3*4 = 12.
        mov     [rsi+rdi].particles.r,ecx;colors[loop*(12/MAX_PARTICLES)][0]
        mov     ecx,colors[rax+4]
        mov     [rsi+rdi].particles.g,ecx;colors[loop*(12/MAX_PARTICLES)][1]
        mov     ecx,colors[rax+8]
        mov     [rsi+rdi].particles.b,ecx;colors[loop*(12/MAX_PARTICLES)][2]

	invoke	nrandom,50                      ; randomize each color component
        cvtsi2ss xmm0,edx
        subss	xmm0,const26
        mulss	xmm0,const10
        movd    [rsi+rdi].particles.xi,xmm0;((rand()%50)-26.0)*10.0

        invoke  nrandom,50
        cvtsi2ss xmm0,edx
        subss	xmm0,const25
        mulss	xmm0,const10
        movd    [rsi+rdi].particles.yi,xmm0;((rand()%50)-25.0)*10.0

        invoke  nrandom,50
        cvtsi2ss xmm0,edx
        subss	xmm0,const25
        mulss	xmm0,const10
        movd	[rsi+rdi].particles.zi,xmm0;((rand()%50)-25.0)*10.0

        and     [rsi+rdi].particles.xg,0
        movr	[rsi+rdi].particles.yg,-0.8
        and     [rsi+rdi].particles.zg,0

        add     edi,sizeof particles
	cmp	edi,MAX_PARTICLES*(sizeof particles)
	jb	@b
	mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd200
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;clear screen before drawing
        invoke	glLoadIdentity ; 
	movd	xmm6,const1	
	movd	xmm7,const0_5	
	mov     esi,particle
	xor     edi,edi    
@0:     mov     eax,[rsi+rdi].particles.x
        mov     x,eax
        mov     eax,[rsi+rdi].particles.y
        mov     y,eax
        movd    xmm0,[rsi+rdi].particles.z
        addss   xmm0,zoom
        movd    z,xmm0
	movd	xmm3,[rsi+rdi].particles.life
	movd	xmm2,[rsi+rdi].particles.b
	movd	xmm1,[rsi+rdi].particles.g
	movd	xmm0,[rsi+rdi].particles.r
        invoke  glColor4f
        invoke  glBegin,GL_TRIANGLE_STRIP
	movss	xmm1,xmm6
	movss	xmm0,xmm1
        invoke  glTexCoord2f;,1,1 ; since parameters are not very easy
	movd	xmm2,z            ; to compute, I don't use invoke here                           
	movd	xmm1,y            ; to have better control over the stack
	addss	xmm1,xmm7
	movd	xmm0,x
        addss	xmm0,xmm7
        invoke  glVertex3f

	movss	xmm1,xmm6
	xorps	xmm0,xmm0
        invoke  glTexCoord2f;,0,1
	movd	xmm2,z
	movd	xmm1,y
	addss	xmm1,xmm7
	movd	xmm0,x
	subss	xmm0,xmm7
	invoke	glVertex3f

	xorps	xmm1,xmm1
	movss	xmm0,xmm6
        invoke  glTexCoord2f;,1,0
	movd	xmm2,z
	movd	xmm1,y
	subss	xmm1,xmm7
	movd	xmm0,x
	addss	xmm0,xmm7
	invoke	glVertex3f

	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
        invoke  glTexCoord2f;,0,0
	movd	xmm2,z
	movd	xmm1,y
	subss	xmm1,xmm7
	movd	xmm0,x
	subss	xmm0,xmm7
	invoke	glVertex3f
	invoke  glEnd

	movd	xmm0,slowdown                        ; store slowdown*1000 in tmp so we don't
	mulss	xmm0,const1000                    ; have to compute it each time

	movd	xmm1,[rsi+rdi].particles.xi
	divss	xmm1,xmm0;tmp
	addss	xmm1,[rsi+rdi].particles.x
	movd    [rsi+rdi].particles.x,xmm1
	movd	xmm1,[rsi+rdi].particles.yi
	divss	xmm1,xmm0;tmp
	addss	xmm1,[rsi+rdi].particles.y
	movd    [rsi+rdi].particles.y,xmm1
	movss	xmm1,[rsi+rdi].particles.zi
	divss	xmm1,xmm0;    tmp
	addss	xmm1,[rsi+rdi].particles.z
	movd	[rsi+rdi].particles.z,xmm1

	movd	xmm0,[rsi+rdi].particles.xi
	addss	xmm0,[rsi+rdi].particles.xg
	movd    [rsi+rdi].particles.xi,xmm0
	movd	xmm0,[rsi+rdi].particles.yi
	addss	xmm0,[rsi+rdi].particles.yg
	movd	[rsi+rdi].particles.yi,xmm0
	movd	xmm0,[rsi+rdi].particles.zi
	addss	xmm0,[rsi+rdi].particles.zg
	movd	[rsi+rdi].particles.zi,xmm0

	movd	xmm0,[rsi+rdi].particles.life
	subss	xmm0,[rsi+rdi].particles.fade
	movd	[rsi+rdi].particles.life,xmm0

	mov     eax,[rsi+rdi].particles.life; compare 0 and particle.life, set al
	or	eax,eax                     ; if life is less than 0       
	jns	@f                          ; if particle.life < 0        
      
	movr	[rsi+rdi].particles.life,1.0;3F800000h
        invoke  nrandom,100
        cvtsi2ss xmm0,edx
	divss	xmm0,const1000
	addss	xmm0,const0_003
	movd	[rsi+rdi].particles.fade,xmm0
	and     [rsi+rdi].particles.x,0
        and     [rsi+rdi].particles.y,0
        and     [rsi+rdi].particles.z,0
	invoke	nrandom,60
	cvtsi2ss xmm0,edx
	subss	xmm0,const32
	addss	xmm0,xspeed
	movd	[rsi+rdi].particles.xi,xmm0
	invoke  nrandom,60
        cvtsi2ss xmm0,edx
	subss	xmm0,const30
	addss	xmm0,yspeed
	movd	[rsi+rdi].particles.yi,xmm0
	invoke  nrandom,60
        cvtsi2ss xmm0,edx
	subss	xmm0,const30
	movd	[rsi+rdi].particles.zi,xmm0

	imul	eax,col,12
        mov     edx,colors[rax]
	mov     [rsi+rdi].particles.r,edx
	mov     edx,colors[rax+4]
	mov     [rsi+rdi].particles.g,edx
	mov     edx,colors[rax+8]
	mov     [rsi+rdi].particles.b,edx
@@:     add     edi,sizeof particles
	cmp	edi,MAX_PARTICLES*(sizeof particles)
	jb	@0
;   
        invoke  glFlush
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
nrandom PROC base:dword
	mov	base,ecx

	mov	eax,nseed
	xor	edx,edx
	mov	ecx,127773
	div	ecx
	mov	ecx,eax
	mov	eax,16807
	mul	edx
	mov	edx,ecx
	mov	ecx,eax
	mov	eax,2836
	mul	edx
	sub	ecx,eax
	xor	edx,edx
	mov	eax,ecx
	mov	nseed,ecx
	div	base
	leave
	retn
nrandom ENDP
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "Uncle Remus tales:#40 OpenGL - 19-th NeHe lesson",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "particle.bmp",0
Texture1_Id	dq ?
;flat--------------------------
const0_003	dd 0.003
const0_01	dd 0.01
const0_1	dd 0.1
const0_5	dd 0.5
const1		dd 1.0
const4		dd 4.0
const10		dd 10.0
const25		dd 25.0
const26		dd 26.0
const30		dd 30.0
const32		dd 32.0
const200	dd 200.0
const_200       dd -200.0
const1000	dd 1000.0
;double----------------------------
constd0_1	dq 0.1
constd45	dq 45.0
constd200	dq 200.0

xspeed		dd ?
yspeed		dd ?
col     	dd 0
texture		dd ?	; Texture handle
nseed		dd ?
particle	dd ?;particles MAX_PARTICLES dup(<>)
zoom		dd -40.0
rainbow		db 1
slowdown	dd 2.0
colors		dd 1.0,0.5,0.5, 1.0,0.75,0.5, 1.0,1.0,0.5, 0.75,1.0,0.5,\
                   0.5,1.0,0.5, 0.5,1.0,0.75, 0.5,1.0,1.0, 0.5,0.75,1.0,\
                   0.5,0.5,1.0, 0.75,0.5,1.0, 1.0,0.5,1.0, 1.0,0.5,0.75
end